diff --git a/pki/base/silent/src/com/netscape/pkisilent/ConfigureCA.java b/pki/base/silent/src/com/netscape/pkisilent/ConfigureCA.java
index 4dc77b8943845a5218bcb778c7ffe27318669837..df6b531ff7361f74733174d0cd84ca31e8261012 100644
--- a/pki/base/silent/src/com/netscape/pkisilent/ConfigureCA.java
+++ b/pki/base/silent/src/com/netscape/pkisilent/ConfigureCA.java
@@ -93,7 +93,6 @@ public class ConfigureCA {
     public static String base_dn = null;
     public static String db_name = null;
     public static String secure_conn = null;
-    public static String clone_start_tls = null;
     public static String remove_data = null;
 
     public static String key_type = null;
@@ -179,6 +178,9 @@ public class ConfigureCA {
     public static String clone_uri = null;
     public static String clone_p12_passwd = null;
     public static String clone_p12_file = null;
+    public static String clone_master_port = null;
+    public static String clone_replica_port = null;
+    public static String clone_replication_security = null;
 
     //for correct selection of CA to be cloned
     public static String urls;
@@ -267,7 +269,7 @@ public class ConfigureCA {
             // Software Token
             if (token_name.equalsIgnoreCase("internal")) {
                 query_string = "p=1" + "&op=next" + "&xml=true" + "&choice="
-                        + URLEncoder.encode("Internal Key Storage Token") + "";
+                        + URLEncoder.encode("Internal Key Storage Token", "UTF-8") + "";
                 hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
                 if (!checkStatus(hr, "updateStatus", SUCCESS, "TokenChoicePanel()")) {
                     return false;
@@ -276,8 +278,8 @@ public class ConfigureCA {
             else {
                 // login to hsm first
                 query_string = "p=2" + "&op=next" + "&xml=true" + "&uTokName="
-                        + URLEncoder.encode(token_name) + "&__uPasswd="
-                        + URLEncoder.encode(token_pwd) + "";
+                        + URLEncoder.encode(token_name, "UTF-8") + "&__uPasswd="
+                        + URLEncoder.encode(token_pwd, "UTF-8") + "";
                 hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
                 if (!checkStatus(hr, "updateStatus", SUCCESS, "TokenChoicePanel()")) {
                     return false;
@@ -285,7 +287,7 @@ public class ConfigureCA {
 
                 // choice with token name now
                 query_string = "p=1" + "&op=next" + "&xml=true" + "&choice="
-                        + URLEncoder.encode(token_name) + "";
+                        + URLEncoder.encode(token_name, "UTF-8") + "";
                 hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
                 if (!checkStatus(hr, "updateStatus", SUCCESS, "TokenChoicePanel()")) {
                     return false;
@@ -306,12 +308,12 @@ public class ConfigureCA {
             String query_string = null;
 
             if (!clone) {
-                query_string = "sdomainURL=" + URLEncoder.encode(domain_url)
-                        + "&sdomainName=" + URLEncoder.encode(domain_name)
+                query_string = "sdomainURL=" + URLEncoder.encode(domain_url, "UTF-8")
+                        + "&sdomainName=" + URLEncoder.encode(domain_name, "UTF-8")
                         + "&choice=newdomain" + "&p=3" + "&op=next" + "&xml=true";
             } else {
                 domain_url = "https://" + sd_hostname + ":" + sd_admin_port;
-                query_string = "sdomainURL=" + URLEncoder.encode(domain_url)
+                query_string = "sdomainURL=" + URLEncoder.encode(domain_url, "UTF-8")
                         + "&sdomainName="
                         + "&choice=existingdomain" + "&p=3" + "&op=next" + "&xml=true";
             }
@@ -348,12 +350,12 @@ public class ConfigureCA {
             String subca_url = "https://" + cs_hostname + ":" + cs_port +
                     "/ca/admin/console/config/wizard" + "?p=5&subsystem=CA";
 
-            String query_string = "url=" + URLEncoder.encode(subca_url);
+            String query_string = "url=" + URLEncoder.encode(subca_url, "UTF-8");
 
             hr = hc.sslConnect(sd_hostname, sd_admin_port, sd_login_uri, query_string);
 
-            String query_string_1 = "uid=" + sd_admin_name + "&pwd=" + URLEncoder.encode(sd_admin_password) +
-                                    "&url=" + URLEncoder.encode(subca_url);
+            String query_string_1 = "uid=" + sd_admin_name + "&pwd=" + URLEncoder.encode(sd_admin_password, "UTF-8") +
+                                    "&url=" + URLEncoder.encode(subca_url, "UTF-8");
 
             hr = hc.sslConnect(sd_hostname, sd_admin_port, sd_get_cookie_uri,
                                                 query_string_1);
@@ -397,11 +399,11 @@ public class ConfigureCA {
             if (!clone) {
                 query_string = "p=5" + "&op=next" + "&xml=true"
                         + "&choice=newsubsystem" + "&subsystemName="
-                        + URLEncoder.encode(subsystem_name);
+                        + URLEncoder.encode(subsystem_name, "UTF-8");
             } else {
                 query_string = "p=5" + "&op=next" + "&xml=true"
                         + "&choice=clonesubsystem" + "&subsystemName="
-                        + URLEncoder.encode(subsystem_name)
+                        + URLEncoder.encode(subsystem_name, "UTF-8")
                         + "&urls=" + urls + "";
             }
 
@@ -433,8 +435,8 @@ public class ConfigureCA {
             HTTPResponse hr = null;
 
             String query_string = "p=7" + "&op=next" + "&xml=true"
-                    + "&__password=" + URLEncoder.encode(clone_p12_passwd)
-                    + "&path=" + URLEncoder.encode(clone_p12_file) + "";
+                    + "&__password=" + URLEncoder.encode(clone_p12_passwd, "UTF-8")
+                    + "&path=" + URLEncoder.encode(clone_p12_file, "UTF-8") + "";
 
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
             if (!checkStatus(hr, "updateStatus", SUCCESS, "RestoreKeyCertPanel()")) {
@@ -477,15 +479,17 @@ public class ConfigureCA {
             HTTPResponse hr = null;
 
             String query_string = "p=9" + "&op=next" + "&xml=true" + "&host="
-                    + URLEncoder.encode(ldap_host) + "&port="
-                    + URLEncoder.encode(ldap_port) + "&binddn="
-                    + URLEncoder.encode(bind_dn) + "&__bindpwd="
-                    + URLEncoder.encode(bind_password) + "&basedn="
-                    + URLEncoder.encode(base_dn) + "&database="
-                    + URLEncoder.encode(db_name) + "&display="
-                    + URLEncoder.encode("$displayStr")
+                    + URLEncoder.encode(ldap_host,"UTF-8") + "&port="
+                    + URLEncoder.encode(ldap_port,"UTF-8") + "&binddn="
+                    + URLEncoder.encode(bind_dn, "UTF-8") + "&__bindpwd="
+                    + URLEncoder.encode(bind_password, "UTF-8") + "&basedn="
+                    + URLEncoder.encode(base_dn, "UTF-8") + "&database="
+                    + URLEncoder.encode(db_name, "UTF-8") + "&display="
+                    + URLEncoder.encode("$displayStr", "UTF-8")
                     + (secure_conn.equals("true") ? "&secureConn=on" : "")
-                    + (clone_start_tls.equals("true") ? "&cloneStartTLS=on" : "")
+                    + "&masterReplicationPort=" + URLEncoder.encode(clone_master_port, "UTF-8")
+                    + "&cloneReplicationPort=" + URLEncoder.encode(clone_replica_port, "UTF-8")
+                    + "&replicationSecurity=" + URLEncoder.encode(clone_replication_security, "UTF-8")
                     + (remove_data.equals("true") ? "&removeData=true" : "");
 
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
@@ -607,16 +611,16 @@ public class ConfigureCA {
 
             if (!clone) {
                 query_string = "p=11" + "&op=next" + "&xml=true" + "&subsystem="
-                        + URLEncoder.encode(ca_subsystem_cert_subject_name)
+                        + URLEncoder.encode(ca_subsystem_cert_subject_name, "UTF-8")
                         + "&ocsp_signing="
-                        + URLEncoder.encode(ca_ocsp_cert_subject_name) + "&signing="
-                        + URLEncoder.encode(ca_sign_cert_subject_name) + "&sslserver="
-                        + URLEncoder.encode(ca_server_cert_subject_name) + "&audit_signing="
-                        + URLEncoder.encode(ca_audit_signing_cert_subject_name) + "&urls=0"
+                        + URLEncoder.encode(ca_ocsp_cert_subject_name, "UTF-8") + "&signing="
+                        + URLEncoder.encode(ca_sign_cert_subject_name, "UTF-8") + "&sslserver="
+                        + URLEncoder.encode(ca_server_cert_subject_name, "UTF-8") + "&audit_signing="
+                        + URLEncoder.encode(ca_audit_signing_cert_subject_name, "UTF-8") + "&urls=0"
                         + "";
             } else {
                 query_string = "p=11" + "&op=next" + "&xml=true" + "&sslserver="
-                        + URLEncoder.encode(ca_server_cert_subject_name) + "&urls=0"
+                        + URLEncoder.encode(ca_server_cert_subject_name, "UTF-8") + "&urls=0"
                         + "";
             }
 
@@ -744,13 +748,13 @@ public class ConfigureCA {
             HTTPResponse hr = null;
 
             String query_string = "p=12" + "&op=next" + "&xml=true" + "&subsystem="
-                    + URLEncoder.encode(ca_subsystem_cert_cert) + "&subsystem_cc="
-                    + "&ocsp_signing=" + URLEncoder.encode(ocsp_cert_cert)
+                    + URLEncoder.encode(ca_subsystem_cert_cert, "UTF-8") + "&subsystem_cc="
+                    + "&ocsp_signing=" + URLEncoder.encode(ocsp_cert_cert, "UTF-8")
                     + "&ocsp_signing_cc=" + "&signing="
-                    + URLEncoder.encode(ca_cert_cert) + "&signing_cc="
-                    + "&audit_signing=" + URLEncoder.encode(ca_audit_signing_cert_cert)
+                    + URLEncoder.encode(ca_cert_cert, "UTF-8") + "&signing_cc="
+                    + "&audit_signing=" + URLEncoder.encode(ca_audit_signing_cert_cert, "UTF-8")
                     + "&audit_signing_cc="
-                    + "&sslserver=" + URLEncoder.encode(server_cert_cert)
+                    + "&sslserver=" + URLEncoder.encode(server_cert_cert, "UTF-8")
                     + "&sslserver_cc=" + "";
 
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
@@ -778,14 +782,14 @@ public class ConfigureCA {
             String genString = "...certificate be generated internally...";
 
             String query_string = "p=12" + "&op=apply" + "&xml=true" + "&subsystem="
-                    + URLEncoder.encode(genString) + "&subsystem_cc="
-                    + "&ocsp_signing=" + URLEncoder.encode(genString)
+                    + URLEncoder.encode(genString, "UTF-8") + "&subsystem_cc="
+                    + "&ocsp_signing=" + URLEncoder.encode(genString, "UTF-8")
                     + "&ocsp_signing_cc=" + "&signing="
-                    + URLEncoder.encode(ca_cert_cert) + "&signing_cc="
-                    + URLEncoder.encode(signing_cc)
-                    + "&audit_signing=" + URLEncoder.encode(genString)
+                    + URLEncoder.encode(ca_cert_cert, "UTF-8") + "&signing_cc="
+                    + URLEncoder.encode(signing_cc, "UTF-8")
+                    + "&audit_signing=" + URLEncoder.encode(genString, "UTF-8")
                     + "&audit_signing_cc="
-                    + "&sslserver=" + URLEncoder.encode(genString)
+                    + "&sslserver=" + URLEncoder.encode(genString, "UTF-8")
                     + "&sslserver_cc=" + "";
 
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
@@ -866,8 +870,8 @@ public class ConfigureCA {
 
             if (save_p12.equalsIgnoreCase("true")) {
                 String query_string = "p=13" + "&op=next" + "&xml=true"
-                        + "&choice=backupkey" + "&__pwd=" + URLEncoder.encode(backup_pwd)
-                        + "&__pwdagain=" + URLEncoder.encode(backup_pwd);
+                        + "&choice=backupkey" + "&__pwd=" + URLEncoder.encode(backup_pwd, "UTF-8")
+                        + "&__pwdagain=" + URLEncoder.encode(backup_pwd, "UTF-8");
 
                 hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
                 if (!checkStatus(hr, "updateStatus", SUCCESS, "BackupPanel()")) {
@@ -990,14 +994,14 @@ public class ConfigureCA {
 
             String query_string = "p=16" + "&op=next" + "&xml=true"
                     + "&cert_request_type=" + "crmf" + "&uid=" + admin_user
-                    + "&name=" + admin_user + "&__pwd=" + URLEncoder.encode(admin_password)
-                    + "&__admin_password_again=" + URLEncoder.encode(admin_password) + "&profileId="
-                    + "caAdminCert" + "&email=" + URLEncoder.encode(admin_email)
-                    + "&cert_request=" + URLEncoder.encode(admin_cert_request)
-                    + "&subject=" + URLEncoder.encode(agent_cert_subject)
+                    + "&name=" + admin_user + "&__pwd=" + URLEncoder.encode(admin_password, "UTF-8")
+                    + "&__admin_password_again=" + URLEncoder.encode(admin_password, "UTF-8") + "&profileId="
+                    + "caAdminCert" + "&email=" + URLEncoder.encode(admin_email, "UTF-8")
+                    + "&cert_request=" + URLEncoder.encode(admin_cert_request, "UTF-8")
+                    + "&subject=" + URLEncoder.encode(agent_cert_subject, "UTF-8")
                     + "&clone=new"
                     + "&import=true" + "&securitydomain="
-                    + URLEncoder.encode(domain_name) + "";
+                    + URLEncoder.encode(domain_name, "UTF-8") + "";
 
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
             if (!checkStatus(hr, "updateStatus", SUCCESS, "AdminCertReqPanel()")) {
@@ -1079,7 +1083,7 @@ public class ConfigureCA {
             ParseXML px = new ParseXML();
 
             String query_string = "p=17" + "&op=next" + "&xml=true" + "&caHost="
-                    + URLEncoder.encode("/") + "&caPort=" + URLEncoder.encode("/")
+                    + URLEncoder.encode("/", "UTF-8") + "&caPort=" + URLEncoder.encode("/", "UTF-8")
                     + "";
 
             hr = hc.sslConnect(cs_hostname, cs_port, wizard_uri, query_string);
@@ -1335,7 +1339,6 @@ public class ConfigureCA {
         StringHolder x_base_dn = new StringHolder();
         StringHolder x_db_name = new StringHolder();
         StringHolder x_secure_conn = new StringHolder();
-        StringHolder x_clone_start_tls = new StringHolder();
         StringHolder x_remove_data = new StringHolder();
 
         // key properties (defaults)
@@ -1381,7 +1384,6 @@ public class ConfigureCA {
         StringHolder x_backup_fname = new StringHolder();
 
         // separate key size for agent cert
-
         StringHolder x_agent_key_size = new StringHolder();
         StringHolder x_agent_key_type = new StringHolder();
         StringHolder x_agent_cert_subject = new StringHolder();
@@ -1407,6 +1409,9 @@ public class ConfigureCA {
         StringHolder x_clone_uri = new StringHolder();
         StringHolder x_clone_p12_file = new StringHolder();
         StringHolder x_clone_p12_passwd = new StringHolder();
+        StringHolder x_clone_master_port = new StringHolder();
+        StringHolder x_clone_replica_port = new StringHolder();
+        StringHolder x_clone_replication_security = new StringHolder();
 
         //security domain
         StringHolder x_sd_hostname = new StringHolder();
@@ -1448,9 +1453,6 @@ public class ConfigureCA {
         parser.addOption("-secure_conn %s #use ldaps port (optional, default is false)", x_secure_conn);
         parser.addOption("-remove_data %s #remove existing data under base_dn (optional, default is false) ",
                 x_remove_data);
-        parser.addOption(
-                "-clone_start_tls %s #use startTLS for cloning replication agreement (optional, default is false)",
-                x_clone_start_tls);
 
         // key and algorithm options (default)
         parser.addOption("-key_type %s #Key type [RSA,ECC] (optional, default is RSA)", x_key_type);
@@ -1554,6 +1556,14 @@ public class ConfigureCA {
                 x_clone_p12_file);
         parser.addOption("-clone_p12_password %s #Password for pk12 file (optional, required if -clone=true)",
                 x_clone_p12_passwd);
+        
+        // replication agreement options
+        parser.addOption("-clone_master_port %s #Master Port to be used in replication agreement (optional)",
+                x_clone_master_port);
+        parser.addOption("-clone_replica_port %s #Replica Port to be used in replication agreement (optional)",
+                x_clone_replica_port);
+        parser.addOption("-clone_replication_security %s #Type of security in replication agreement (optional)",
+                x_clone_replication_security);
 
         parser.addOption("-sd_hostname %s #Security Domain Hostname (optional, required if -clone=true)", x_sd_hostname);
         parser.addOption("-sd_ssl_port %s #Security Domain SSL EE port (optional, required if -clone=true)",
@@ -1599,7 +1609,6 @@ public class ConfigureCA {
         db_name = x_db_name.value;
         secure_conn = set_default(x_secure_conn.value, "false");
         remove_data = set_default(x_remove_data.value, "false");
-        clone_start_tls = set_default(x_clone_start_tls.value, "false");
 
         key_type = set_default(x_key_type.value, DEFAULT_KEY_TYPE);
         signing_key_type = set_default(x_signing_key_type.value, key_type);
@@ -1663,6 +1672,9 @@ public class ConfigureCA {
         clone_uri = x_clone_uri.value;
         clone_p12_file = x_clone_p12_file.value;
         clone_p12_passwd = x_clone_p12_passwd.value;
+        clone_master_port = set_default(x_clone_master_port.value, "");
+        clone_replica_port = set_default(x_clone_replica_port.value, "");
+        clone_replication_security = set_default(x_clone_replication_security.value, "None");
 
         sd_hostname = x_sd_hostname.value;
         sd_ssl_port = x_sd_ssl_port.value;
